//
//  testView.m
//  sc
//
//  Created by xcc on 09/08/15.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "testView.h"


@implementation testView
@synthesize delegate;

- (id)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
		
    }
    return self;
}

- (void)drawRect:(CGRect)rect {
	CGContextRef context = UIGraphicsGetCurrentContext();
	CGContextSetRGBFillColor(context, 0.5, 0.5, 0.5, 1.0);
	CGContextSetRGBStrokeColor(context, 0.5, 0.5, 0.5, 1.0);
	UIFont *font = [UIFont systemFontOfSize:12]; 
	CGPoint origin = self.frame.origin;
	double left = self.bounds.origin.x;
	double top = self.bounds.origin.y;
	double right = left + self.bounds.size.width;
	double bottom = top + self.bounds.size.height;
	for (double v = top; v < bottom; v += 100.0) {
		for (double h = left; h < right; h += 100.0) {
			NSString* str = [NSString stringWithFormat:@"[%.0lf, %.0lf]", h + origin.x, v + origin.y];
			[str drawAtPoint:CGPointMake(h, v) withFont:font]; 
		}
	}
	for (double v = top; v < bottom; v += 100.0) {
		CGContextMoveToPoint(context, left, v);
		CGContextAddLineToPoint(context, right, v);
		CGContextStrokePath(context);	
	}
	for (double h = left; h < right; h += 100.0) {
		CGContextMoveToPoint(context, h, top);
		CGContextAddLineToPoint(context, h, bottom);
		CGContextStrokePath(context);	
	}
}

- (void)dealloc {
    [super dealloc];
}


- (void)setZoomScale:(double)inScale {
}

/*
	シングルタップ
*/
- (void)handleSingleTap {
    if ([delegate respondsToSelector:@selector(view:gotSingleTapAtPoint:)])
        [delegate view:self gotSingleTapAtPoint:tapLocation];
}

/*
	ダブルタップ
*/
- (void)handleDoubleTap {
    if ([delegate respondsToSelector:@selector(view:gotDoubleTapAtPoint:)])
        [delegate view:self gotDoubleTapAtPoint:tapLocation];
}

#define DOUBLE_TAP_DELAY 0.35

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
	/*
		もし、このメソッドの前にhandleSingleTapが登録されていて実行待ちであれば
		DOUBLE_TAP_DELAY間隔のあいだにtouchesBeganが2度来た事になる。
		それはダブルタップとみなすべきなので、handleSingleTap登録は解除する。
		もともと登録が無ければ、この処理はなにも影響をおよぼさない。
	*/
	printf("testView touchesBegan\n");
    [NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(handleSingleTap) object:nil];
}

- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event
{
	printf("testView touchesEnded\n");
	UITouch *touch = [touches anyObject];
	tapLocation = [touch locationInView:self];
	if ([touch tapCount] == 1) {
		[self performSelector:@selector(handleSingleTap) withObject:nil afterDelay:DOUBLE_TAP_DELAY];
	} else if([touch tapCount] == 2) {
		[self handleDoubleTap];
	}
}

@end
